<template>
  <div id="changePassword">
    <div class="title-page">
      Profile Settings
    </div>
    <div class="content">
      <h3 class="title">{{ $t('auth.change_password.title') }}</h3>
      <div class="form-group">
        <input
          @keyup.enter="changePassword"
          v-validate="'required|min:6'"
          @focus="resetError"
          data-vv-validate-on="none"
          v-model="currentPassword"
          type="password"
          :placeholder="$t('auth.change_password.current')"
          data-vv-as="current password"
          name="current_password"
          class="input">
        <span class="invalid-feedback" v-if="errors.has('current_password')">{{ errors.first('current_password') }}</span>
      </div>
      <div class="form-group">
        <input data-vv-as="new password"
           @keyup.enter="changePassword"
           v-validate="'required|min:6|max:128|regex:^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d).+$|no_space|confirmed:password_confirmation'"
           @focus="resetError"
           :placeholder="$t('auth.change_password.new')"
           v-model="newPassword"
           data-vv-validate-on="none"
           name="password"
           type="password"
           class="input">
        <span class="invalid-feedback" v-if="isShowPasswordError">{{ errors.first('password') }}</span>
      </div>
      <div class="form-group">
        <input
          data-vv-as="password confirmation"
          @keyup.enter="changePassword"
          ref="password_confirmation"
          v-validate="'required'"
          @focus="resetError"
          data-vv-validate-on="none"
          :placeholder="$t('auth.change_password.repeat')"
          v-model="passwordConfirmation"
          name="password_confirmation"
          type="password"
          class="input">
        <span class="invalid-feedback" v-if="isShowPasswordConfirmedError">{{ errors.first('password') }}</span>
        <span class="invalid-feedback" v-if="errors.has('password_confirmation')">{{ errors.first('password_confirmation') }}</span>
      </div>
      <div class="form_actions">
        <button class="btn-change" type="button" @click="changePassword()">{{ $t('auth.change_password.button') }}</button>
      </div>
    </div>
  </div>
</template>
<script>
import rf from '../../common/requests/RequestFactory';
import OtpConfirmModal from '../components/Modal/OtpConfirmModal.vue';

export default {
  data() {
    return {
      currentPassword: null,
      newPassword: null,
      passwordConfirmation: null,
    }
  },
  computed: {
    isShowPasswordError () {
      return this.errors.has('password') && !this.errors.firstByRule('password', 'confirmed');
    },
    isShowPasswordConfirmedError () {
      return !!this.errors.firstByRule('password', 'confirmed') && !this.errors.firstByRule('password_confirmation', 'required');
    }
  },
  props: {
    modalData: {
      type: Object,
    }
  },
  methods: {
    closeModal() {
      this.$broadcast('close-modal');
    },
    resetError() {
      this.errors.clear();
    },
    changePassword() {
      this.$validator.validateAll()
      .then(() => {
        if (this.errors.any()) {
          return;
        }
        const params = Object.assign({}, {
          current_password: this.currentPassword,
          password: this.newPassword,
          password_confirmation: this.passwordConfirmation,
        });
        rf.getRequest('UserRequest')
          .changePassword(params)
          .then(() => {
            this.closeModal();
            this.changePasswordSuccessful();
          })
          .catch((error) => {
            const errors = error.errors;
            this.errors.clear();
            Object.keys(errors).forEach((key) => {
              this.errors.add({
                field: key,
                msg: errors[key][0]
              });
            });
            if (this.errors.has('code')) {
              this.$broadcast('open-modal', OtpConfirmModal, {
                callback: this.requestChangePassword,
                key: `requestChangePassword`,
                params: params,
              });
            }
          });
      });
    },
    requestChangePassword (params) {
      return rf.getRequest('UserRequest').changePassword(params);
    },
    changePasswordSuccessful () {
      this.$toasted.show(this.$t('messages.auth.changePassword.changePasswordSuccessful'), {
        theme: 'bubble',
        position: 'top-right',
        duration : 1000
      });

      setTimeout(() => {
        window.location.href = '/login';
      }, 1000);
    },
  },
  created () {
    this.$on(`requestChangePassword-confirm-otp-successful`, () => {
      this.changePasswordSuccessful();
    });
  },
};
</script>
<style scoped lang="scss">
  @import '../../../sass/mobile/typoVariables.scss';

  * {
    font-family: $font-family-home;
  }
  #changePassword {
    .title-page {
      padding: 13rem 12rem 13rem;
      background-image: linear-gradient(to bottom, $midnight, $catalina_blue);
      box-shadow: 0 2rem 40rem 0 rgba(0, 0, 0, 0.5);
      font-size: 18rem;
      color: $white;
    }
    .content {
      height: calc(100vh - 420rem);
      min-height: 440rem;
      background: $bg_primary;
      padding: 15rem 12rem;
      .title {
        font-size: 16rem;
        font-weight: bold;
        line-height: 3.13;
        color: #1c1c1c;
        margin-bottom: 8rem;
      }
      .form-group {
        position: relative;
        width: 100%;
        height: 40rem;
        margin-bottom: 20rem;
        input {
          width: 100%;
          height: 40rem;
          border-radius: 74rem;
          border: none;
          outline: none;
          padding: 20rem;
          background: #ffffff;
          font-size: 14rem;
          &:placeholder {
            color: #cacaca;
          }
          &:focus {
            box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
          }
        }
      }
    }
    .btn-change {
      margin-top: 19rem;
      background: #fa7300;
      width: 170rem;
      height: 32rem;
      border-radius: 30rem;
      border: solid 1rem #fa7300;
      font-size: 12rem;
      font-weight: bold;
      letter-spacing: 0.5rem;
      outline: none;
      color: white;
      text-transform: uppercase;
    }

    .invalid-feedback {
      color: red;
      position: absolute;
      text-align: left;
      bottom: -20rem;
      font-size: 13rem;
      left: 15rem;
    }
  }
  .form_actions {
    text-align: center;
  }
</style>
